From 2cf17507b90fe9b30ba65f54cac8f37b5ffe1bce Mon Sep 17 00:00:00 2001
From: Diego Novillo <dnovillo@google.com>
Date: Mon, 21 Jan 2013 14:52:06 -0500
Subject: [PATCH] Remove zone allocator.

This patch removes the GC zone allocator.  It is not used and it
produces several regressions in the testsuite.  Furthermore, it
complicates things for the plan to implement manual GC markers
(http://gcc.gnu.org/wiki/cxx-conversion/gc-alternatives#Do_GC_marking_manually).

Tested on x86_64 with standard checking, --enable-checking=gc and
--enable-checking=release.
---
 gcc/ChangeLog        |   49 +
 gcc/Makefile.in      |    9 +-
 gcc/configure        |   26 +-
 gcc/configure.ac     |   24 +-
 gcc/doc/install.texi |    6 -
 gcc/gengtype.c       |  141 +--
 gcc/ggc-common.c     |   14 +-
 gcc/ggc-internal.h   |    6 +-
 gcc/ggc-none.c       |   35 -
 gcc/ggc-page.c       |   24 +-
 gcc/ggc-zone.c       | 2526 --------------------------------------------------
 gcc/ggc.h            |  102 +-
 gcc/rtl.c            |    5 +-
 gcc/stringpool.c     |    2 +-
 gcc/tree-phinodes.c  |    4 -
 gcc/tree-ssanames.c  |    5 +-
 gcc/tree.c           |   19 +-
 gcc/varasm.c         |    2 +-
 18 files changed, 110 insertions(+), 2889 deletions(-)
 delete mode 100644 gcc/ggc-zone.c

diff --git a/gcc/ChangeLog b/gcc/ChangeLog
index bf0a47b..20f44e8 100644
--- a/gcc/ChangeLog
+++ b/gcc/ChangeLog
@@ -1,3 +1,52 @@
+2013-01-24  Diego Novillo  <dnovillo@google.com>
+
+	* Makefile.in (GGC): Remove.  Replace all instances with
+	ggc-page.o.
+	(ggc-zone.o): Remove.
+	* configure.ac: Remove option --with-gc.
+	* configure: Re-generate.
+	* doc/install.texi: Remove documentation for --with-gc.
+	* gengtype.c (write_enum_defn): Remove.  Update all users.
+	(write_Types_process_field): Remove generation of gt_e_* argument.
+	(output_type_enum): Remove.  Update all users.
+	(write_enum_defn): Remove.  Update all users.
+	(enum alloc_zone): Remove.  Update all users.
+	(write_splay_tree_allocator_def): Remove generation of gt_e_*
+	argument.
+	* ggc-common.c (ggc_splay_alloc): Remove first argument.
+	Update all callers.
+	(struct ptr_data): Remove field TYPE.  Update all users.
+	(gt_pch_note_object): Remove argument TYPE.  Update all
+	users.
+	* ggc-internal.h (ggc_pch_alloc_object): Remove last argument.
+	Update all users.
+	* gcc/ggc-none.c (ggc_alloc_typed_stat): Remove.
+	(struct alloc_zone): Remove.
+	(ggc_internal_alloc_zone_stat): Remove.
+	(ggc_internal_cleared_alloc_zone_stat): Remove.
+	* ggc-page.c (ggc_alloc_typed_stat): Remove.
+	(ggc_pch_count_object): Remove last argument.  Update all
+	users.
+	(ggc_pch_alloc_object): Remove last argument.  Update all
+	users.
+	(struct alloc_zone): Remove.
+	* ggc-zone.c: Remove.
+	* ggc.h (gt_pch_note_object): Remove last argument.  Update
+	all users.
+	(struct alloc_zone): Remove.
+	(ggc_alloc_typed_stat): Remove.
+	(ggc_alloc_typed): Remove.
+	(ggc_splay_alloc): Remove first argument.
+	(rtl_zone): Remove.  Update all users.
+	(tree_zone): Remove.  Update all users.
+	(tree_id_zone): Remove.  Update all users.
+	(ggc_internal_zone_alloc_stat): Remove.  Update all users.
+	(ggc_internal_zone_cleared_alloc_stat): Remove.  Update all
+	users.
+	(ggc_internal_zone_vec_alloc_stat): Remove.  Update all users.
+	* tree-ssanames.c: Remove references to zone allocator in
+	comments.
+
 2013-01-24  Georg-Johann Lay  <avr@gjlay.de>
 
 	* config/avr/avr.c (avr_out_fract): Make register numbers that
diff --git a/gcc/configure.ac b/gcc/configure.ac
index 3703a20..24568f1 100644
--- a/gcc/configure.ac
+++ b/gcc/configure.ac
@@ -4797,26 +4797,14 @@ if test x$gcc_cv_target_dl_iterate_phdr = xyes; then
 fi
 AC_MSG_RESULT($gcc_cv_target_dl_iterate_phdr)
 
-# Find out what GC implementation we want, or may, use.
+# We no longer support different GC mechanisms.  Emit an error if
+# the user configures with --with-gc.
 AC_ARG_WITH(gc,
 [AS_HELP_STRING([--with-gc={page,zone}],
-		[choose the garbage collection mechanism to use
-                 with the compiler])],
-[case "$withval" in
-  page)
-    GGC=ggc-$withval
-    ;;
-  zone)
-    GGC=ggc-$withval
-    AC_DEFINE(GGC_ZONE, 1, [Define if the zone collector is in use])
-    ;;
-  *)
-    AC_MSG_ERROR([$withval is an invalid option to --with-gc])
-    ;;
-esac],
-[GGC=ggc-page])
-AC_SUBST(GGC)
-echo "Using $GGC for garbage collection."
+		[this option is not supported anymore.  It used to choose
+		 the garbage collection mechanism to use with the compiler])],
+[AC_MSG_ERROR([Configure option --with-gc is only supported up to GCC 4.7.x])],
+[])
 
 # Libraries to use on the host.  This will normally be set by the top
 # level Makefile.  Here we simply capture the value for our Makefile.
diff --git a/gcc/gengtype.c b/gcc/gengtype.c
index 2a158e9..a2eebf2 100644
--- a/gcc/gengtype.c
+++ b/gcc/gengtype.c
@@ -2414,7 +2414,6 @@ static void write_local_func_for_structure
   (const_type_p orig_s, type_p s, type_p *param);
 static void write_local (outf_p output_header,
 			 type_p structures, type_p param_structs);
-static void write_enum_defn (type_p structures, type_p param_structs);
 static int contains_scalar_p (type_p t);
 static void put_mangled_filename (outf_p, const input_file *);
 static void finish_root_table (struct flist *flp, const char *pfx,
@@ -3169,20 +3168,6 @@ write_types_process_field (type_p f, const struct walk_type_data *d)
 	    }
 	  else
 	    oprintf (d->of, ", gt_%sa_%s", wtd->param_prefix, d->prev_val[0]);
-
-	  if (f->u.p->kind == TYPE_PARAM_STRUCT
-	      && f->u.p->u.s.line.file != NULL)
-	    {
-	      oprintf (d->of, ", gt_e_");
-	      output_mangled_typename (d->of, f);
-	    }
-	  else if (union_or_struct_p (f) && f->u.p->u.s.line.file != NULL)
-	    {
-	      oprintf (d->of, ", gt_ggc_e_");
-	      output_mangled_typename (d->of, f);
-	    }
-	  else
-	    oprintf (d->of, ", gt_types_enum_last");
 	}
       oprintf (d->of, ");\n");
       if (d->reorder_fn && wtd->reorder_note_routine)
@@ -3227,25 +3212,6 @@ write_types_process_field (type_p f, const struct walk_type_data *d)
     }
 }
 
-/* A subroutine of write_func_for_structure.  Write the enum tag for S.  */
-
-static void
-output_type_enum (outf_p of, type_p s)
-{
-  if (s->kind == TYPE_PARAM_STRUCT && s->u.param_struct.line.file != NULL)
-    {
-      oprintf (of, ", gt_e_");
-      output_mangled_typename (of, s);
-    }
-  else if (union_or_struct_p (s) && s->u.s.line.file != NULL)
-    {
-      oprintf (of, ", gt_ggc_e_");
-      output_mangled_typename (of, s);
-    }
-  else
-    oprintf (of, ", gt_types_enum_last");
-}
-
 /* Return an output file that is suitable for definitions which can
    reference struct S */
 
@@ -3520,7 +3486,6 @@ write_func_for_structure (type_p orig_s, type_p s, type_p *param,
 	{
 	  oprintf (d.of, ", x, gt_%s_", wtd->param_prefix);
 	  output_mangled_typename (d.of, orig_s);
-	  output_type_enum (d.of, orig_s);
 	}
       oprintf (d.of, "))\n");
     }
@@ -3534,7 +3499,6 @@ write_func_for_structure (type_p orig_s, type_p s, type_p *param,
 	{
 	  oprintf (d.of, ", xlimit, gt_%s_", wtd->param_prefix);
 	  output_mangled_typename (d.of, orig_s);
-	  output_type_enum (d.of, orig_s);
 	}
       oprintf (d.of, "))\n");
       if (chain_circular != NULL)
@@ -3568,7 +3532,6 @@ write_func_for_structure (type_p orig_s, type_p s, type_p *param,
 	    {
 	      oprintf (d.of, ", xprev, gt_%s_", wtd->param_prefix);
 	      output_mangled_typename (d.of, orig_s);
-	      output_type_enum (d.of, orig_s);
 	    }
 	  oprintf (d.of, ");\n");
 	  oprintf (d.of, "      }\n");
@@ -3580,7 +3543,6 @@ write_func_for_structure (type_p orig_s, type_p s, type_p *param,
 	    {
 	      oprintf (d.of, ", xlimit, gt_%s_", wtd->param_prefix);
 	      output_mangled_typename (d.of, orig_s);
-	      output_type_enum (d.of, orig_s);
 	    }
 	  oprintf (d.of, "));\n");
 	  if (mark_hook_name && !wtd->skip_hooks)
@@ -4091,50 +4053,6 @@ write_local (outf_p output_header, type_p structures, type_p param_structs)
 	       && strncmp (s->u.s.tag, "anonymous", strlen ("anonymous"))))))
 
 
-/* Write out the 'enum' definition for gt_types_enum.  */
-
-static void
-write_enum_defn (type_p structures, type_p param_structs)
-{
-  type_p s;
-  int nbstruct = 0;
-  int nbparamstruct = 0;
-
-  if (!header_file)
-    return;
-  oprintf (header_file, "\n/* Enumeration of types known.  */\n");
-  oprintf (header_file, "enum gt_types_enum {\n");
-  for (s = structures; s; s = s->next)
-    if (USED_BY_TYPED_GC_P (s))
-      {
-	nbstruct++;
-	DBGPRINTF ("write_enum_defn s @ %p nbstruct %d",
-		   (void*) s, nbstruct);
-	if (union_or_struct_p (s))
-	  DBGPRINTF ("write_enum_defn s %p #%d is unionorstruct tagged %s",
-		     (void*) s, nbstruct, s->u.s.tag);
-	oprintf (header_file, " gt_ggc_e_");
-	output_mangled_typename (header_file, s);
-	oprintf (header_file, ",\n");
-      }
-  for (s = param_structs; s; s = s->next)
-    if (s->gc_used == GC_POINTED_TO)
-      {
-	nbparamstruct++;
-	DBGPRINTF ("write_enum_defn s %p nbparamstruct %d",
-		   (void*) s, nbparamstruct);
-	oprintf (header_file, " gt_e_");
-	output_mangled_typename (header_file, s);
-	oprintf (header_file, ",\n");
-      }
-  oprintf (header_file, " gt_types_enum_last\n");
-  oprintf (header_file, "};\n");
-  if (verbosity_level >= 2)
-    printf ("%s handled %d GTY-ed structures & %d parameterized structures.\n",
-	    progname, nbstruct, nbparamstruct);
-
-}
-
 /* Might T contain any non-pointer elements?  */
 
 static int
@@ -4804,38 +4722,30 @@ variable_size_p (const type_p s)
 
 enum alloc_quantity
 { single, vector };
-enum alloc_zone
-{ any_zone, specific_zone };
 
 /* Writes one typed allocator definition into output F for type
    identifier TYPE_NAME with optional type specifier TYPE_SPECIFIER.
    The allocator name will contain ALLOCATOR_TYPE.  If VARIABLE_SIZE
    is true, the allocator will have an extra parameter specifying
    number of bytes to allocate.  If QUANTITY is set to VECTOR, a
-   vector allocator will be output, if ZONE is set to SPECIFIC_ZONE,
-   the allocator will be zone-specific.  */
+   vector allocator will be output.  */
 
 static void
 write_typed_alloc_def (outf_p f, 
                        bool variable_size, const char *type_specifier,
                        const char *type_name, const char *allocator_type,
-                       enum alloc_quantity quantity, enum alloc_zone zone)
+                       enum alloc_quantity quantity)
 {
   bool two_args = variable_size && (quantity == vector);
-  bool third_arg = ((zone == specific_zone)
-		    && (variable_size || (quantity == vector)));
   gcc_assert (f != NULL);
   const char *type_name_as_id = filter_type_name (type_name);
   oprintf (f, "#define ggc_alloc_%s%s", allocator_type, type_name_as_id);
-  oprintf (f, "(%s%s%s%s%s) ",
+  oprintf (f, "(%s%s%s) ",
 	   (variable_size ? "SIZE" : ""),
 	   (two_args ? ", " : ""),
-	   (quantity == vector) ? "n" : "",
-	   (third_arg ? ", " : ""), (zone == specific_zone) ? "z" : "");
+	   (quantity == vector) ? "n" : "");
   oprintf (f, "((%s%s *)", type_specifier, type_name);
   oprintf (f, "(ggc_internal_%salloc_stat (", allocator_type);
-  if (zone == specific_zone)
-    oprintf (f, "z, ");
   if (variable_size)
     oprintf (f, "SIZE");
   else
@@ -4853,12 +4763,11 @@ write_typed_alloc_def (outf_p f,
 static void
 write_typed_struct_alloc_def (outf_p f,
 			      const type_p s, const char *allocator_type,
-			      enum alloc_quantity quantity,
-			      enum alloc_zone zone)
+			      enum alloc_quantity quantity)
 {
   gcc_assert (union_or_struct_p (s));
   write_typed_alloc_def (f, variable_size_p (s), get_type_specifier (s),
-                         s->u.s.tag, allocator_type, quantity, zone);
+                         s->u.s.tag, allocator_type, quantity);
 }
 
 /* Writes a typed allocator definition into output F for a typedef P,
@@ -4867,11 +4776,10 @@ write_typed_struct_alloc_def (outf_p f,
 static void
 write_typed_typedef_alloc_def (outf_p f,
                                const pair_p p, const char *allocator_type,
-                               enum alloc_quantity quantity,
-                               enum alloc_zone zone)
+                               enum alloc_quantity quantity)
 {
   write_typed_alloc_def (f, variable_size_p (p->type), "", p->name,
-                         allocator_type, quantity, zone);
+                         allocator_type, quantity);
 }
 
 /* Writes typed allocator definitions into output F for the types in
@@ -4897,16 +4805,10 @@ write_typed_alloc_defns (outf_p f,
       if (nb_plugin_files > 0 
 	  && ((s->u.s.line.file == NULL) || !s->u.s.line.file->inpisplugin))
 	continue;
-      write_typed_struct_alloc_def (f, s, "", single, any_zone);
-      write_typed_struct_alloc_def (f, s, "cleared_", single, any_zone);
-      write_typed_struct_alloc_def (f, s, "vec_", vector, any_zone);
-      write_typed_struct_alloc_def (f, s, "cleared_vec_", vector, any_zone);
-      write_typed_struct_alloc_def (f, s, "zone_", single, specific_zone);
-      write_typed_struct_alloc_def (f, s, "zone_cleared_", single,
-				    specific_zone);
-      write_typed_struct_alloc_def (f, s, "zone_vec_", vector, specific_zone);
-      write_typed_struct_alloc_def (f, s, "zone_cleared_vec_", vector,
-				    specific_zone);
+      write_typed_struct_alloc_def (f, s, "", single);
+      write_typed_struct_alloc_def (f, s, "cleared_", single);
+      write_typed_struct_alloc_def (f, s, "vec_", vector);
+      write_typed_struct_alloc_def (f, s, "cleared_vec_", vector);
     }
 
   oprintf (f, "\n/* Allocators for known typedefs.  */\n");
@@ -4923,15 +4825,10 @@ write_typed_alloc_defns (outf_p f,
 	  if (!filoc || !filoc->file->inpisplugin)
 	    continue;
 	};
-      write_typed_typedef_alloc_def (f, p, "", single, any_zone);
-      write_typed_typedef_alloc_def (f, p, "cleared_", single, any_zone);
-      write_typed_typedef_alloc_def (f, p, "vec_", vector, any_zone);
-      write_typed_typedef_alloc_def (f, p, "cleared_vec_", vector, any_zone);
-      write_typed_typedef_alloc_def (f, p, "zone_", single, specific_zone);
-      write_typed_typedef_alloc_def (f, p, "zone_cleared_", single,
-				     specific_zone);
-      write_typed_typedef_alloc_def (f, p, "zone_cleared_vec_", vector,
-				     specific_zone);
+      write_typed_typedef_alloc_def (f, p, "", single);
+      write_typed_typedef_alloc_def (f, p, "cleared_", single);
+      write_typed_typedef_alloc_def (f, p, "vec_", vector);
+      write_typed_typedef_alloc_def (f, p, "cleared_vec_", vector);
     }
 }
 
@@ -4990,10 +4887,7 @@ write_splay_tree_allocator_def (const_type_p s)
   output_typename (of, s);
   oprintf (of, " (int sz, void * nl)\n");
   oprintf (of, "{\n");
-  oprintf (of, "  return ggc_splay_alloc (");
-  oprintf (of, "gt_e_");
-  output_mangled_typename (of, s);
-  oprintf (of, ", sz, nl);\n");
+  oprintf (of, "  return ggc_splay_alloc (sz, nl);\n");
   oprintf (of, "}\n\n");
 }
 
@@ -5647,7 +5541,6 @@ main (int argc, char **argv)
 
   open_base_files ();
 
-  write_enum_defn (structures, param_structs);
   output_header = plugin_output ? plugin_output : header_file;
   write_typed_alloc_defns (output_header, structures, typedefs);
   DBGPRINT_COUNT_TYPE ("structures before write_types outputheader",
diff --git a/gcc/ggc-common.c b/gcc/ggc-common.c
index 70930a3..f02224a 100644
--- a/gcc/ggc-common.c
+++ b/gcc/ggc-common.c
@@ -250,8 +250,7 @@ ggc_cleared_alloc_ptr_array_two_args (size_t c, size_t n)
 
 /* These are for splay_tree_new_ggc.  */
 void *
-ggc_splay_alloc (enum gt_types_enum obj_type ATTRIBUTE_UNUSED, int sz,
-		 void *nl)
+ggc_splay_alloc (int sz, void *nl)
 {
   gcc_assert (!nl);
   return ggc_internal_alloc (sz);
@@ -300,7 +299,6 @@ struct ptr_data
   gt_handle_reorder reorder_fn;
   size_t size;
   void *new_addr;
-  enum gt_types_enum type;
 };
 
 #define POINTER_HASH(x) (hashval_t)((intptr_t)x >> 3)
@@ -309,8 +307,7 @@ struct ptr_data
 
 int
 gt_pch_note_object (void *obj, void *note_ptr_cookie,
-		    gt_note_pointers note_ptr_fn,
-		    enum gt_types_enum type)
+		    gt_note_pointers note_ptr_fn)
 {
   struct ptr_data **slot;
 
@@ -335,7 +332,6 @@ gt_pch_note_object (void *obj, void *note_ptr_cookie,
     (*slot)->size = strlen ((const char *)obj) + 1;
   else
     (*slot)->size = ggc_get_size (obj);
-  (*slot)->type = type;
   return 1;
 }
 
@@ -391,8 +387,7 @@ call_count (void **slot, void *state_p)
   struct traversal_state *state = (struct traversal_state *)state_p;
 
   ggc_pch_count_object (state->d, d->obj, d->size,
-			d->note_ptr_fn == gt_pch_p_S,
-			d->type);
+			d->note_ptr_fn == gt_pch_p_S);
   state->count++;
   return 1;
 }
@@ -404,8 +399,7 @@ call_alloc (void **slot, void *state_p)
   struct traversal_state *state = (struct traversal_state *)state_p;
 
   d->new_addr = ggc_pch_alloc_object (state->d, d->obj, d->size,
-				      d->note_ptr_fn == gt_pch_p_S,
-				      d->type);
+				      d->note_ptr_fn == gt_pch_p_S);
   state->ptrs[state->ptrs_i++] = d;
   return 1;
 }
diff --git a/gcc/ggc-internal.h b/gcc/ggc-internal.h
index 1559883..0219615 100644
--- a/gcc/ggc-internal.h
+++ b/gcc/ggc-internal.h
@@ -55,8 +55,7 @@ extern struct ggc_pch_data *init_ggc_pch (void);
    of an object.  Update the ggc_pch_data structure with as much of
    that information as is necessary. The bool argument should be true
    if the object is a string.  */
-extern void ggc_pch_count_object (struct ggc_pch_data *, void *, size_t, bool,
-				  enum gt_types_enum);
+extern void ggc_pch_count_object (struct ggc_pch_data *, void *, size_t, bool);
 
 /* Return the total size of the data to be written to hold all
    the objects previously passed to ggc_pch_count_object.  */
@@ -69,8 +68,7 @@ extern void ggc_pch_this_base (struct ggc_pch_data *, void *);
 /* Assuming that the objects really do end up at the address
    passed to ggc_pch_this_base, return the address of this object.
    The bool argument should be true if the object is a string.  */
-extern char *ggc_pch_alloc_object (struct ggc_pch_data *, void *, size_t, bool,
-				   enum gt_types_enum);
+extern char *ggc_pch_alloc_object (struct ggc_pch_data *, void *, size_t, bool);
 
 /* Write out any initial information required.  */
 extern void ggc_pch_prepare_write (struct ggc_pch_data *, FILE *);
diff --git a/gcc/ggc-none.c b/gcc/ggc-none.c
index 4d2c0a8..9a9a4e3 100644
--- a/gcc/ggc-none.c
+++ b/gcc/ggc-none.c
@@ -31,13 +31,6 @@
 #include "coretypes.h"
 #include "ggc.h"
 
-void *
-ggc_alloc_typed_stat (enum gt_types_enum ARG_UNUSED (gte), size_t size
-		      MEM_STAT_DECL)
-{
-  return xmalloc (size);
-}
-
 /* For a given size of memory requested for allocation, return the
    actual size that is going to be allocated.  */
 
@@ -70,31 +63,3 @@ ggc_free (void *p)
 {
   free (p);
 }
-
-struct alloc_zone
-{
-  int dummy;
-};
-
-struct alloc_zone rtl_zone;
-struct alloc_zone tree_zone;
-struct alloc_zone tree_id_zone;
-
-#if defined (GGC_ZONE) && !defined (GENERATOR_FILE)
-
-void *
-ggc_internal_alloc_zone_stat (size_t size,
-                              struct alloc_zone * ARG_UNUSED(z) MEM_STAT_DECL)
-{
-    return xmalloc (size);
-}
-
-void *
-ggc_internal_cleared_alloc_zone_stat (size_t size,
-                                      struct alloc_zone * ARG_UNUSED(z)
-                                      MEM_STAT_DECL)
-{
-    return xcalloc (size, 1);
-}
-
-#endif
diff --git a/gcc/ggc-page.c b/gcc/ggc-page.c
index 693753c..32768b2 100644
--- a/gcc/ggc-page.c
+++ b/gcc/ggc-page.c
@@ -1199,15 +1199,6 @@ ggc_round_alloc_size (size_t requested_size)
   return size;
 }
 
-/* Typed allocation function.  Does nothing special in this collector.  */
-
-void *
-ggc_alloc_typed_stat (enum gt_types_enum type ATTRIBUTE_UNUSED, size_t size
-		      MEM_STAT_DECL)
-{
-  return ggc_internal_alloc_stat (size PASS_MEM_STAT);
-}
-
 /* Allocate a chunk of memory of SIZE bytes.  Its contents are undefined.  */
 
 void *
@@ -2230,8 +2221,7 @@ init_ggc_pch (void)
 
 void
 ggc_pch_count_object (struct ggc_pch_data *d, void *x ATTRIBUTE_UNUSED,
-		      size_t size, bool is_string ATTRIBUTE_UNUSED,
-		      enum gt_types_enum type ATTRIBUTE_UNUSED)
+		      size_t size, bool is_string ATTRIBUTE_UNUSED)
 {
   unsigned order;
 
@@ -2274,8 +2264,7 @@ ggc_pch_this_base (struct ggc_pch_data *d, void *base)
 
 char *
 ggc_pch_alloc_object (struct ggc_pch_data *d, void *x ATTRIBUTE_UNUSED,
-		      size_t size, bool is_string ATTRIBUTE_UNUSED,
-		      enum gt_types_enum type ATTRIBUTE_UNUSED)
+		      size_t size, bool is_string ATTRIBUTE_UNUSED)
 {
   unsigned order;
   char *result;
@@ -2507,12 +2496,3 @@ ggc_pch_read (FILE *f, void *addr)
   /* Update the statistics.  */
   G.allocated = G.allocated_last_gc = offs - (char *)addr;
 }
-
-struct alloc_zone
-{
-  int dummy;
-};
-
-struct alloc_zone rtl_zone;
-struct alloc_zone tree_zone;
-struct alloc_zone tree_id_zone;
diff --git a/gcc/ggc.h b/gcc/ggc.h
index 4c424ca..b31bc80 100644
--- a/gcc/ggc.h
+++ b/gcc/ggc.h
@@ -48,8 +48,7 @@ typedef void (*gt_handle_reorder) (void *, void *, gt_pointer_operator,
 				   void *);
 
 /* Used by the gt_pch_n_* routines.  Register an object in the hash table.  */
-extern int gt_pch_note_object (void *, void *, gt_note_pointers,
-			       enum gt_types_enum = gt_types_enum_last);
+extern int gt_pch_note_object (void *, void *, gt_note_pointers);
 
 /* Used by the gt_pch_n_* routines.  Register that an object has a reorder
    function.  */
@@ -118,8 +117,6 @@ extern void gt_ggc_m_S (const void *);
 
 /* End of GTY machinery API.  */
 
-struct alloc_zone;
-
 /* Initialize the string pool.  */
 extern void init_stringpool (void);
 
@@ -146,12 +143,6 @@ extern size_t ggc_round_alloc_size (size_t requested_size);
 
 #define ggc_internal_alloc(s) ggc_internal_alloc_stat (s MEM_STAT_INFO)
 
-/* Allocate an object of the specified type and size.  */
-extern void *ggc_alloc_typed_stat (enum gt_types_enum, size_t MEM_STAT_DECL)
-  ATTRIBUTE_MALLOC;
-
-#define ggc_alloc_typed(s, z) ggc_alloc_typed_stat (s, z MEM_STAT_INFO)
-
 /* Allocates cleared memory.  */
 extern void *ggc_internal_cleared_alloc_stat (size_t MEM_STAT_DECL)
   ATTRIBUTE_MALLOC;
@@ -213,7 +204,7 @@ extern void *ggc_cleared_alloc_ptr_array_two_args (size_t, size_t)
   splay_tree_new_typed_alloc (COMPARE, NULL, NULL, &ALLOC_TREE, &ALLOC_NODE, \
 			      &ggc_splay_dont_free, NULL)
 
-extern void *ggc_splay_alloc (enum gt_types_enum, int, void *)
+extern void *ggc_splay_alloc (int, void *)
   ATTRIBUTE_MALLOC;
 
 extern void ggc_splay_dont_free (void *, void *);
@@ -254,99 +245,28 @@ extern void stringpool_statistics (void);
 /* Heuristics.  */
 extern void init_ggc_heuristics (void);
 
-/* Zone collection.  */
-
-/* For regular rtl allocations.  */
-extern struct alloc_zone rtl_zone;
-
-/* For regular tree allocations.  */
-extern struct alloc_zone tree_zone;
-
-/* For IDENTIFIER_NODE allocations.  */
-extern struct alloc_zone tree_id_zone;
-
-#define ggc_alloc_rtvec_sized(NELT)                                     \
-  ggc_alloc_zone_rtvec_def (sizeof (struct rtvec_def)			\
-			    + ((NELT) - 1) * sizeof (rtx),		\
-			    &rtl_zone)
-
-#if defined (GGC_ZONE) && !defined (GENERATOR_FILE)
-
-/* Allocate an object into the specified allocation zone.  */
-extern void *ggc_internal_alloc_zone_stat (size_t,
-					  struct alloc_zone * MEM_STAT_DECL)
-  ATTRIBUTE_MALLOC;
-
-extern void *ggc_internal_cleared_alloc_zone_stat (size_t,
-					  struct alloc_zone * MEM_STAT_DECL)
-  ATTRIBUTE_MALLOC;
-
-static inline void *
-ggc_internal_zone_alloc_stat (struct alloc_zone * z, size_t s MEM_STAT_DECL)
-{
-    return ggc_internal_alloc_zone_stat (s, z PASS_MEM_STAT);
-}
-
-static inline void *
-ggc_internal_zone_cleared_alloc_stat (struct alloc_zone * z, size_t s
-                                      MEM_STAT_DECL)
-{
-    return ggc_internal_cleared_alloc_zone_stat (s, z PASS_MEM_STAT);
-}
-
-static inline void *
-ggc_internal_zone_vec_alloc_stat (struct alloc_zone * z, size_t s, size_t n
-                                  MEM_STAT_DECL)
-{
-    return ggc_internal_alloc_zone_stat (s * n, z PASS_MEM_STAT);
-}
-
-
-#else
-
-static inline void *
-ggc_internal_zone_alloc_stat (struct alloc_zone * z ATTRIBUTE_UNUSED,
-                              size_t s MEM_STAT_DECL)
-{
-    return ggc_internal_alloc_stat (s PASS_MEM_STAT);
-}
-
-static inline void *
-ggc_internal_zone_cleared_alloc_stat (struct alloc_zone * z ATTRIBUTE_UNUSED,
-                                      size_t s MEM_STAT_DECL)
-{
-    return ggc_internal_cleared_alloc_stat (s PASS_MEM_STAT);
-}
-
-static inline void *
-ggc_internal_zone_vec_alloc_stat (struct alloc_zone * z ATTRIBUTE_UNUSED,
-                                  size_t s, size_t n MEM_STAT_DECL)
-{
-    return ggc_internal_vec_alloc_stat (s, n PASS_MEM_STAT);
-}
-
-#endif
+#define ggc_alloc_rtvec_sized(NELT)				\
+  ggc_alloc_rtvec_def (sizeof (struct rtvec_def)		\
+		       + ((NELT) - 1) * sizeof (rtx))		\
 
 /* Memory statistics passing versions of some allocators.  Too few of them to
    make gengtype produce them, so just define the needed ones here.  */
 static inline struct rtx_def *
-ggc_alloc_zone_rtx_def_stat (struct alloc_zone * z, size_t s MEM_STAT_DECL)
+ggc_alloc_rtx_def_stat (size_t s MEM_STAT_DECL)
 {
-  return (struct rtx_def *) ggc_internal_zone_alloc_stat (z, s PASS_MEM_STAT);
+  return (struct rtx_def *) ggc_internal_alloc_stat (s PASS_MEM_STAT);
 }
 
 static inline union tree_node *
-ggc_alloc_zone_tree_node_stat (struct alloc_zone * z, size_t s MEM_STAT_DECL)
+ggc_alloc_tree_node_stat (size_t s MEM_STAT_DECL)
 {
-  return (union tree_node *) ggc_internal_zone_alloc_stat (z, s PASS_MEM_STAT);
+  return (union tree_node *) ggc_internal_alloc_stat (s PASS_MEM_STAT);
 }
 
 static inline union tree_node *
-ggc_alloc_zone_cleared_tree_node_stat (struct alloc_zone * z, size_t s
-                                       MEM_STAT_DECL)
+ggc_alloc_cleared_tree_node_stat (size_t s MEM_STAT_DECL)
 {
-  return (union tree_node *)
-    ggc_internal_zone_cleared_alloc_stat (z, s PASS_MEM_STAT);
+  return (union tree_node *) ggc_internal_cleared_alloc_stat (s PASS_MEM_STAT);
 }
 
 static inline union gimple_statement_d *
diff --git a/gcc/rtl.c b/gcc/rtl.c
index 38c46fa..bc49fc8 100644
--- a/gcc/rtl.c
+++ b/gcc/rtl.c
@@ -192,8 +192,7 @@ rtx_size (const_rtx x)
 rtx
 rtx_alloc_stat (RTX_CODE code MEM_STAT_DECL)
 {
-  rtx rt = ggc_alloc_zone_rtx_def_stat (&rtl_zone, RTX_CODE_SIZE (code)
-                                        PASS_MEM_STAT);
+  rtx rt = ggc_alloc_rtx_def_stat (RTX_CODE_SIZE (code) PASS_MEM_STAT);
 
   /* We want to clear everything up to the FLD array.  Normally, this
      is one int, but we don't want to assume that and it isn't very
@@ -329,7 +328,7 @@ rtx
 shallow_copy_rtx_stat (const_rtx orig MEM_STAT_DECL)
 {
   const unsigned int size = rtx_size (orig);
-  rtx const copy = ggc_alloc_zone_rtx_def_stat (&rtl_zone, size PASS_MEM_STAT);
+  rtx const copy = ggc_alloc_rtx_def_stat (size PASS_MEM_STAT);
   return (rtx) memcpy (copy, orig, size);
 }
 
diff --git a/gcc/stringpool.c b/gcc/stringpool.c
index 59141e9..f4d0dae 100644
--- a/gcc/stringpool.c
+++ b/gcc/stringpool.c
@@ -207,7 +207,7 @@ void
 gt_pch_n_S (const void *x)
 {
   gt_pch_note_object (CONST_CAST (void *, x), CONST_CAST (void *, x),
-		      &gt_pch_p_S, gt_types_enum_last);
+		      &gt_pch_p_S);
 }
 
 
diff --git a/gcc/tree-phinodes.c b/gcc/tree-phinodes.c
index 03a20fa..4499753 100644
--- a/gcc/tree-phinodes.c
+++ b/gcc/tree-phinodes.c
@@ -42,10 +42,6 @@ along with GCC; see the file COPYING3.  If not see
    garbage collector.  Similar results have been seen on a wider variety
    of tests (such as the compiler itself).
 
-   We could also use a zone allocator for these objects since they have
-   a very well defined lifetime.  If someone wants to experiment with that
-   this is the place to try it.
-
    PHI nodes have different sizes, so we can't have a single list of all
    the PHI nodes as it would be too expensive to walk down that list to
    find a PHI of a suitable size.
diff --git a/gcc/tree-ssanames.c b/gcc/tree-ssanames.c
index 3f35e5d..be078ce 100644
--- a/gcc/tree-ssanames.c
+++ b/gcc/tree-ssanames.c
@@ -50,11 +50,8 @@ along with GCC; see the file COPYING3.  If not see
    External code should also not assume the version number on nodes is
    monotonically increasing.  We reuse the version number when we
    reuse an SSA_NAME expression.  This helps keep arrays and bitmaps
-   more compact.
+   more compact.  */
 
-   We could also use a zone allocator for these objects since they have
-   a very well defined lifetime.  If someone wants to experiment with that
-   this is the place to try it.  */
 
 /* Version numbers with special meanings.  We start allocating new version
    numbers after the special ones.  */
diff --git a/gcc/tree.c b/gcc/tree.c
index 25efd7f..98ad5d8 100644
--- a/gcc/tree.c
+++ b/gcc/tree.c
@@ -857,9 +857,7 @@ make_node_stat (enum tree_code code MEM_STAT_DECL)
 
   record_node_allocation_statistics (code, length);
 
-  t = ggc_alloc_zone_cleared_tree_node_stat (
-               (code == IDENTIFIER_NODE) ? &tree_id_zone : &tree_zone,
-               length PASS_MEM_STAT);
+  t = ggc_alloc_cleared_tree_node_stat (length PASS_MEM_STAT);
   TREE_SET_CODE (t, code);
 
   switch (type)
@@ -953,7 +951,7 @@ copy_node_stat (tree node MEM_STAT_DECL)
 
   length = tree_size (node);
   record_node_allocation_statistics (code, length);
-  t = ggc_alloc_zone_tree_node_stat (&tree_zone, length PASS_MEM_STAT);
+  t = ggc_alloc_tree_node_stat (length PASS_MEM_STAT);
   memcpy (t, node, length);
 
   if (CODE_CONTAINS_STRUCT (code, TS_COMMON))
@@ -1311,7 +1309,7 @@ make_vector_stat (unsigned len MEM_STAT_DECL)
 
   record_node_allocation_statistics (VECTOR_CST, length);
 
-  t = ggc_alloc_zone_cleared_tree_node_stat (&tree_zone, length PASS_MEM_STAT);
+  t = ggc_alloc_cleared_tree_node_stat (length PASS_MEM_STAT);
 
   TREE_SET_CODE (t, VECTOR_CST);
   TREE_CONSTANT (t) = 1;
@@ -1674,7 +1672,7 @@ make_tree_binfo_stat (unsigned base_binfos MEM_STAT_DECL)
 
   record_node_allocation_statistics (TREE_BINFO, length);
 
-  t = ggc_alloc_zone_tree_node_stat (&tree_zone, length PASS_MEM_STAT);
+  t = ggc_alloc_tree_node_stat (length PASS_MEM_STAT);
 
   memset (t, 0, offsetof (struct tree_binfo, base_binfos));
 
@@ -1713,7 +1711,7 @@ make_tree_vec_stat (int len MEM_STAT_DECL)
 
   record_node_allocation_statistics (TREE_VEC, length);
 
-  t = ggc_alloc_zone_cleared_tree_node_stat (&tree_zone, length PASS_MEM_STAT);
+  t = ggc_alloc_cleared_tree_node_stat (length PASS_MEM_STAT);
 
   TREE_SET_CODE (t, TREE_VEC);
   TREE_VEC_LENGTH (t) = len;
@@ -2330,8 +2328,7 @@ tree_cons_stat (tree purpose, tree value, tree chain MEM_STAT_DECL)
 {
   tree node;
 
-  node = ggc_alloc_zone_tree_node_stat (&tree_zone, sizeof (struct tree_list)
-                                        PASS_MEM_STAT);
+  node = ggc_alloc_tree_node_stat (sizeof (struct tree_list) PASS_MEM_STAT);
   memset (node, 0, sizeof (struct tree_common));
 
   record_node_allocation_statistics (TREE_LIST, sizeof (struct tree_list));
@@ -3800,7 +3797,7 @@ build1_stat (enum tree_code code, tree type, tree node MEM_STAT_DECL)
 
   gcc_assert (TREE_CODE_LENGTH (code) == 1);
 
-  t = ggc_alloc_zone_tree_node_stat (&tree_zone, length PASS_MEM_STAT);
+  t = ggc_alloc_tree_node_stat (length PASS_MEM_STAT);
 
   memset (t, 0, sizeof (struct tree_common));
 
@@ -10073,7 +10070,7 @@ build_vl_exp_stat (enum tree_code code, int len MEM_STAT_DECL)
 
   record_node_allocation_statistics (code, length);
 
-  t = ggc_alloc_zone_cleared_tree_node_stat (&tree_zone, length PASS_MEM_STAT);
+  t = ggc_alloc_cleared_tree_node_stat (length PASS_MEM_STAT);
 
   TREE_SET_CODE (t, code);
 
